(* Dies ist ein Pointer-Testprogramm mit einer verknuepften  Liste, *)
(* die durch einen Pointer in Rueckrichtung verbunden ist. Die Ele- *)
(* mente bestehen aus  einer  Struktur  (record),  die zwei weitere *)
(* Strukturen beinhaltet.                                           *)

PROGRAM pointer (input,output);
  TYPE link = ^list_level_1;
       list_level_2a = RECORD
                         element_1 : char
                       END;
       list_level_2b = RECORD
                         element_2 : char
                       END;
       list_level_1  = RECORD
                         list1 : list_level_2a;
                         list2 : list_level_2b;
                         next  : link
                       END;
  VAR p,first   : link;
      index     : integer;
      character : char;

BEGIN

  (* Pointerelemente einlesen *)

  first := NIL;
  FOR index := 1 TO 10 DO
  BEGIN
    write ('->');
    readln (character);
    new (p);
    p^.list1.element_1 := character;
    p^.list2.element_2 := character;
    p^.next := first;
    first := p
  END;

  (* Pointerelemente ausgeben *)

  p := first;
  WHILE (p <> NIL) DO
  BEGIN
    write (p^.list1.element_1);
    write (p^.list2.element_2);
    p := p^.next
  END
END.